[LeetCode] 509. Fibonacci Number 斐波那契數字

 

The Fibonacci numbers, commonly denoted F(n) form a sequence, called the Fibonacci sequence, such that each number is the sum of the two preceding ones, starting from 0 and 1. That is,html

F(0) = 0,   F(1) = 1
F(N) = F(N - 1) + F(N - 2), for N > 1.

Given N, calculate F(N).git

 

Example 1:github

Input: 2
Output: 1
Explanation: F(2) = F(1) + F(0) = 1 + 0 = 1.

Example 2:數組

Input: 3
Output: 2
Explanation: F(3) = F(2) + F(1) = 1 + 1 = 2.

Example 3:post

Input: 4
Output: 3
Explanation: F(4) = F(3) + F(2) = 2 + 1 = 3.

 

Note:優化

0 ≤ N ≤ 30.url

 

這道題是關於斐波那契數列的,這個數列想必咱們都據說過,簡而言之,除了前兩個數字以外,每一個數字等於前兩個數字之和。舉個生動的例子,大學食堂裏今天的湯是昨天的湯加上前天的湯。哈哈,是否是瞬間記牢了。題目沒讓返回整個數列,而是直接讓返回位置爲N的數字。那麼仍是要構建整個斐波那契數組,才能知道位置N上的數字。像這種有規律有 pattern 的數組,最簡單的方法就是使用遞歸啦,先把不合規律的前兩個數字處理了,而後直接對 N-1 和 N-2 調用遞歸,並相加返回便可,參見代碼以下:spa

 

解法一:code

class Solution {
public:
    int fib(int N) {
        if (N <= 1) return N;
        return fib(N - 1) + fib(N - 2);
    }
};

 

上面的寫法雖然簡單,可是並不高效,由於有大量的重複計算,咱們但願每一個值只計算一次,因此可使用動態規劃 Dynamic Programming 來作,創建一個大小爲 N+1 的 dp 數組,其中 dp[i] 爲位置i上的數字,先初始化前兩個分別爲0和1,而後就能夠開始更新整個數組了,狀態轉移方程就是斐波那契數組的性質,最後返回 dp[N] 便可,參見代碼以下:orm

 

解法二:

class Solution {
public:
    int fib(int N) {
        vector<int> dp(N + 1);
        dp[0] = 0; dp[1] = 1;
        for (int i = 2; i <= N; ++i) {
            dp[i] = dp[i - 1] + dp[i - 2];
        }
        return dp[N];
    }
};

 

咱們能夠對上面解法進行空間上的進一步優化,因爲當前數字只跟前兩個數字有關,因此不須要保存整個數組,而是隻須要保存前兩個數字就好了,前一個數字用b表示,再前面的用a表示。a和b分別初始化爲0和1,表明數組的前兩個數字。而後從位置2開始更新,先算出a和b的和 sum,而後a更新爲b,b更新爲 sum。最後返回b便可,參見代碼以下:

 

解法三:

class Solution {
public:
    int fib(int N) {
        if (N <= 1) return N;
        int a = 0, b = 1;
        for (int i = 2; i <= N; ++i) {
            int sum = a + b;
            a = b;
            b = sum;
        }
        return b;
    }
};

 

給下面的這種解法跪了,直接 hardcode 了全部N範圍內的斐波那契數字,而後直接返回,這尼瑪諸葛孔明的棺材板快壓不住了。。。我從未見過如此。。。

 

解法四:

class Solution {
public:
    int fib(int N) {
        vector<int> fibs{0, 1, 1, 2, 3, 5, 8, 13, 21, 34, 55, 89, 144, 233, 377, 610, 987, 1597, 2584, 4181, 6765, 10946, 17711, 28657, 46368, 75025, 121393, 196418, 317811, 514229, 832040};
        return fibs[N];
    }
};

 

Github 同步地址:

https://github.com/grandyang/leetcode/issues/509

 

相似題目:

Split Array into Fibonacci Sequence

Length of Longest Fibonacci Subsequence

 

參考資料:

https://leetcode.com/problems/fibonacci-number/

https://leetcode.com/problems/fibonacci-number/discuss/215992/Java-Solutions

https://leetcode.com/problems/fibonacci-number/discuss/216245/Java-O(1)-time

 

LeetCode All in One 題目講解彙總(持續更新中...)

相關文章
相關標籤/搜索